#include "B4RDefines.h"

B4R::Serial* b4r_main::_serial1;
B4R::Timer* b4r_main::_updatetimer;
B4R::B4RStream* b4r_main::_serialnative2;
B4R::AsyncStreams* b4r_main::_astream;
B4R::B4RSerializator* b4r_main::_ser;
static B4R::Serial be_gann1_3;
static B4R::Timer be_gann2_3;
static B4R::B4RStream be_gann3_3;
static B4R::AsyncStreams be_gann4_3;
static B4R::B4RSerializator be_gann5_3;


 HardwareSerial Serial2(2); // Second Hardware Port
void SerialNative2(B4R::Object* unused)
{
::Serial2.begin(115200);
b4r_main::_serialnative2->wrappedStream = &::Serial2;
}
void b4r_main::_appstart(){
const UInt cp = B4R::StackMemory::cp;
 //BA.debugLineNum = 30;BA.debugLine="Private Sub AppStart";
 //BA.debugLineNum = 31;BA.debugLine="Serial1.Initialize(115200)";
b4r_main::_serial1->Initialize((ULong) (115200));
 //BA.debugLineNum = 32;BA.debugLine="RunNative(\"SerialNative2\", Null)";
Common_RunNative(SerialNative2,Common_Null);
 //BA.debugLineNum = 33;BA.debugLine="UpdateTimer.Initialize(\"UpdateTimer_Tick\", 250) '";
b4r_main::_updatetimer->Initialize(_updatetimer_tick,(ULong) (250));
 //BA.debugLineNum = 34;BA.debugLine="astream.Initialize(SerialNative2,\"Astream_NewData";
b4r_main::_astream->Initialize(b4r_main::_serialnative2,_astream_newdata,_astream_error);
 //BA.debugLineNum = 35;BA.debugLine="UpdateTimer.Enabled = True";
b4r_main::_updatetimer->setEnabled(Common_True);
 //BA.debugLineNum = 36;BA.debugLine="Log(\"AppStart\")";
B4R::Common::LogHelper(1,102,F("AppStart"));
 //BA.debugLineNum = 37;BA.debugLine="End Sub";
B4R::StackMemory::cp = cp;
}
void b4r_main::_astream_error(){
const UInt cp = B4R::StackMemory::cp;
 //BA.debugLineNum = 48;BA.debugLine="Sub AStream_Error";
 //BA.debugLineNum = 50;BA.debugLine="End Sub";
B4R::StackMemory::cp = cp;
}
void b4r_main::_astream_newdata(B4R::Array* _buffer){
const UInt cp = B4R::StackMemory::cp;
B4R::Object be_ann16_4e1[10];
B4R::Array be_ann16_4e2;
B4R::Object* be_ann16_4e3[10];
B4R::Array* _be = NULL;
B4R::Array* _data = NULL;
 //BA.debugLineNum = 40;BA.debugLine="Sub AStream_NewData (Buffer() As Byte)";
 //BA.debugLineNum = 41;BA.debugLine="Dim be(10) As Object";
_be =be_ann16_4e2.wrapObjects((void**)be_ann16_4e3,be_ann16_4e1,10, sizeof(B4R::Object));
 //BA.debugLineNum = 42;BA.debugLine="Dim data() As Object = ser.ConvertBytesToArray(Bu";
_data = b4r_main::_ser->ConvertBytesToArray(_buffer,_be);
 //BA.debugLineNum = 43;BA.debugLine="Log(data(0))";
B4R::Common::LogHelper(1,100,((B4R::Object**)_data->getData((UInt) (0)))[B4R::Array::staticIndex]);
 //BA.debugLineNum = 44;BA.debugLine="Log(data(1))";
B4R::Common::LogHelper(1,100,((B4R::Object**)_data->getData((UInt) (1)))[B4R::Array::staticIndex]);
 //BA.debugLineNum = 45;BA.debugLine="End Sub";
B4R::StackMemory::cp = cp;
}

void b4r_main::initializeProcessGlobals() {
     B4R::StackMemory::buffer = (byte*)malloc(STACK_BUFFER_SIZE);
     b4r_main::_process_globals();

   
}
void b4r_main::_process_globals(){
const UInt cp = B4R::StackMemory::cp;
 //BA.debugLineNum = 8;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 9;BA.debugLine="Public Serial1 As Serial";
b4r_main::_serial1 = &be_gann1_3;
 //BA.debugLineNum = 10;BA.debugLine="Private UpdateTimer As Timer";
b4r_main::_updatetimer = &be_gann2_3;
 //BA.debugLineNum = 11;BA.debugLine="Private SerialNative2 As Stream";
b4r_main::_serialnative2 = &be_gann3_3;
 //BA.debugLineNum = 12;BA.debugLine="Private astream As AsyncStreams					' B4x method";
b4r_main::_astream = &be_gann4_3;
 //BA.debugLineNum = 13;BA.debugLine="Dim ser As B4RSerializator";
b4r_main::_ser = &be_gann5_3;
 //BA.debugLineNum = 14;BA.debugLine="End Sub";
}
void b4r_main::_sendoutstring(B4R::B4RString* _text){
const UInt cp = B4R::StackMemory::cp;
Byte be_ann24_4e1[20];
B4R::Array be_ann24_4e2;
B4R::Array* _buffer = NULL;
Int _i = 0;
B4R::Object be_ann28_2;
 //BA.debugLineNum = 54;BA.debugLine="Public Sub SendOutString(text As String)";
 //BA.debugLineNum = 55;BA.debugLine="Dim Buffer(20) As Byte";
_buffer =be_ann24_4e2.wrap(be_ann24_4e1,20);
 //BA.debugLineNum = 56;BA.debugLine="For i = 0 To text.Length-1";
{
const int step2 = 1;
const int limit2 = (Int) (_text->getLength()-1);
_i = 0 ;
for (;(step2 > 0 && _i <= limit2) || (step2 < 0 && _i >= limit2) ;_i = ((Int)(0 + _i + step2))  ) {
 //BA.debugLineNum = 57;BA.debugLine="Buffer(i)=text.GetBytes(i)";
((Byte*)_buffer->getData((UInt) (_i)))[B4R::Array::staticIndex] = ((Byte*)_text->GetBytes()->getData((UInt) (_i)))[B4R::Array::staticIndex];
 }
};
 //BA.debugLineNum = 59;BA.debugLine="Log(Buffer)";
B4R::Common::LogHelper(1,100,be_ann28_2.wrapPointer(_buffer));
 //BA.debugLineNum = 60;BA.debugLine="astream.Write(Buffer)";
b4r_main::_astream->Write(_buffer);
 //BA.debugLineNum = 61;BA.debugLine="End Sub";
B4R::StackMemory::cp = cp;
}
void b4r_main::_updatetimer_tick(){
const UInt cp = B4R::StackMemory::cp;
B4R::B4RString be_ann32_2;
 //BA.debugLineNum = 63;BA.debugLine="Private Sub UpdateTimer_Tick";
 //BA.debugLineNum = 64;BA.debugLine="SendOutString(\"0123456789\")";
_sendoutstring(be_ann32_2.wrap("0123456789"));
 //BA.debugLineNum = 65;BA.debugLine="End Sub";
B4R::StackMemory::cp = cp;
}
